/*
 * File:   C05h.c    06.09.2009
 * Author: j.zdenek
 *
 */

#include <stdio.h>
#include <stdlib.h>

// Programovaci styly - Citac /proceduralni styl - reseni 5
// struktura, ukazatel na funkci, pole ukazatelu na funkci, typedef
// podmineny preklad (Conditional compilation)

#define TYP_CITACE 1    // 1 - myCounterA, 2 - myCounterB

typedef struct {
    int *value ;
    int (*operation[5])(); // array of function pointers
    void (*initialize)();
}Tcounter;

// Function prototypes
int konec (Tcounter *counter);
int zvetsi (Tcounter *counter);
int zmensi (Tcounter *counter);
int nastav (Tcounter *counter);
int hodnota (Tcounter *counter);
void initHodnotu (Tcounter *counter, int *hodnota);

Tcounter counterA = {NULL,&konec,&zvetsi,&zmensi,&nastav,&hodnota,&initHodnotu};
Tcounter counterB = {NULL,&konec,&zvetsi,&zmensi,&nastav,&hodnota,&initHodnotu};

int main(int argc, char** argv) {
    enum boolean {FALSE,TRUE};
    int myCounterA, myCounterB;
    printf(" === C05h.c ===\n\n");
    printf(" Citac / proceduralni styl - reseni 5 \n\n");
#if TYP_CITACE == 1
    (*counterA.initialize)(&counterA,&myCounterA);
    do {
        // == Kompaktni zapis cinnosti == pomoci typedef Tcounter
        printf(" == CITAC A == \n\n");
        printf("\n Hodnota = %d \n\n",(*counterA.operation[menu()])(&counterA));
    } while(TRUE);
#endif
#if TYP_CITACE == 2
    (*counterB.initialize)(&counterB,&myCounterB);
    do {
        // == Kompaktni zapis cinnosti == pomoci typedef Tcounter
        printf(" == CITAC B == \n\n");
        printf("\n Hodnota = %d \n\n",(*counterB.operation[menu()])(&counterB));
    } while(TRUE);
#endif
    return (EXIT_SUCCESS);
}// main() END

void initHodnotu (Tcounter *counter, int *hodnota){
    counter->value = hodnota;
    *counter->value = 0;
}// initHodnotu() END

int konec (Tcounter *counter){
    printf("\n Konec programu \n\n");
    exit(EXIT_SUCCESS);
}// konec() END

int zvetsi (Tcounter *counter){
   (*counter->value)++;
    return(*counter->value);
}// zvetsi() END

int zmensi (Tcounter *counter){
    (*counter->value)--;
    return(*counter->value);
}// zmensi() END

int nastav (Tcounter *counter){
    *counter->value = 0;
    return(*counter->value);
}// nastav() END

int hodnota (Tcounter *counter){
    return(*counter->value);
}// hodnota() END

int menu (void) {
    enum boolean {FALSE,TRUE};
    int volba;
    do {
        printf(" 0. Konec \n");
        printf(" 1. Zvetsi \n");
        printf(" 2. Zmensi \n");
        printf(" 3. Nastav \n");
        printf(" 4. Hodnota \n");
        printf("\n Vase volba: ");
        if(!nextInt(&volba) || volba < 0 || volba > 4){
            printf("\n Nepovolena volba \n\n");
        }else{
            return(volba);
        }
    } while (TRUE);
}// menu() END

int nextInt(int *cislo){
    // Stav: odladeno
    // === Bezpecne pro libovolny zadany pocet znaku ===
    // Navratova hodnota:
    // TRUE  - zadano cele cislo
    // FALSE - neplatny vstup
    enum boolean {FALSE,TRUE};
    const int BUF_SIZE = 80;
    char vstup[BUF_SIZE],smeti[BUF_SIZE];
    fgets(vstup,sizeof(vstup),stdin);
    if(sscanf(vstup,"%i%[^\n]",cislo,smeti) != 1)
        return(FALSE); // Input error
    return(TRUE);
}// nextInt1() END

