/*
 * File:   C06b.c    25.08.2009 (rev: 06.09.2009)
 * Author: j.zdenek
 *
 */

#include <stdio.h>
#include <stdlib.h>

// Pole - Otoc pole pomoci funkci, predavani parametru typu pole

// Function prototypes
int ctiPole (int p[], int max_delka);
int nextInt(int *cislo);
void obratPole (int p[], int delka_pole);
void vypisPole (int p[], int delka_pole);

int main(int argc, char** argv) {
    #define MAX_DELKA 20
    int pole[MAX_DELKA], n;
    printf(" === C06b.c ===\n\n");
    printf(" Obrat pole - pomoci funkci \n\n");
    n = ctiPole(pole, MAX_DELKA);
    obratPole(pole, n);
    vypisPole(pole, n);
    return (EXIT_SUCCESS);
}// main() END

int ctiPole (int p[], int max_delka){
    // Pole p[] se predava odkazem (call by reference)
    int n, i;
    printf(" Zadejte pocet cisel = ");
    if (!nextInt(&n)) {
        printf("\n Chyba - Zadany udaj neni cele cislo\n\n");
        exit(EXIT_FAILURE);
    }
    if(n <1 || n > max_delka){
        printf("\n Chyba - pocet cisel = <1,%d> \n\n",MAX_DELKA);
        exit(EXIT_FAILURE);
    }
    printf("\n Zadejte cela cisla (kazde ukoncit ENTER)\n\n");
    for (i = 0; i < n; i++) {
        if (!nextInt(&p[i])) {
            printf("\n Chyba - Zadany udaj neni cele cislo\n\n");
            exit(EXIT_FAILURE);
        }
    }
    return(n);
}// ctiPole() END

void obratPole (int p[], int delka_pole){
    // Pole p[] se predava odkazem (call by reference)
    int i, x, n_pul;
    n_pul= delka_pole/2;
    for(i=0; i<n_pul; i++ ){
        x = p[i];
        p[i] = p[delka_pole-i-1];
        p[delka_pole-i-1] = x;
    }
}// obratPole() END

void vypisPole (int p[], int delka_pole){
    // Pole p[] se predava odkazem (call by reference)
    int i;
    printf("\n Vypis cisel v obracenem poradi \n\n");
    for(i=0; i<delka_pole; i++){
        printf("pole[%d] = %d \n", i, p[i]);
    }
    printf(" \n");
}// vypisPole() END

int nextInt(int *cislo){
    // Stav: odladeno
    // === Bezpecne pro libovolny zadany pocet znaku ===
    // Navratova hodnota:
    // TRUE  - zadano cele cislo
    // FALSE - neplatny vstup
    enum boolean {FALSE,TRUE};
    const int BUF_SIZE = 80;
    char vstup[BUF_SIZE],smeti[BUF_SIZE];
    fgets(vstup,sizeof(vstup),stdin);
    if(sscanf(vstup,"%i%[^\n]",cislo,smeti) != 1)
        return(FALSE); // Input error
    return(TRUE);
}// nextInt1() END


