/*
 * File:   C06c.c    25.08.2009 (rev: 06.09.2009)
 * Author: j.zdenek
 *
 */

#include <stdio.h>
#include <stdlib.h>

// Pole - Tabulka cetnosti, predavani parametru typu pole

// Function prototypes
int tabulka(int t[], int min, int max);
void vypis (int t[], int min, int max);
int nextInt(int *cislo);

int main(int argc, char** argv) {
    #define MIN 1
    #define MAX 100
    int tab[MAX - MIN + 1]; // Pozor, lokalni promenna neni inicializovana
    printf(" === C06c.c ===\n\n");
    printf(" Cetnost cisel - pomoci funkci \n\n");
    if (!tabulka(tab, MIN, MAX)) {
        printf(" Chyba v zadani udaju\n\n");
        return(EXIT_FAILURE);
    }
    vypis(tab, MIN, MAX);
    return (EXIT_SUCCESS);
}// main() END

int tabulka(int t[], int min, int max) {
    const int TRUE = 1;
    const int FALSE = 0;
    int i, cislo;
    for (i = 0; i <= (max - min); i++){
        t[i] = 0;
    }
    printf(" Zadejte radu celych cisel zakoncenou nulou \n\n");
    printf(" Povoleny rozsah cisel je <%d, %d> \n\n", min, max);
    do {
        if (!nextInt(&cislo)) {
            printf("\n Chyba - Zadany udaj neni cele cislo\n");
            return (FALSE); // FALSE -> chyba
        }
        if ((cislo < MIN || cislo > MAX) && cislo != 0) {
            printf("\n Chyba - Zadane cislo je mimo rozsah\n");
            return (FALSE); // FALSE -> chyba
        }
        if (cislo == 0)break;
        t[cislo - MIN]++;
    } while (TRUE);
    return (TRUE); // Zadani bez chyby
}// tabulka() END

void vypis (int t[], int min, int max){
    int i;
    printf("\n");
    for(i=0; i<=(max-min); i++){
        if(t[i] != 0){
            printf(" Cetnost cisla  %3d  je  %3d\n", (i+MIN),t[i]);
        }
    }
    printf("\n");
}// vypis() END

int nextInt(int *cislo){
    // Stav: odladeno
    // === Bezpecne pro libovolny zadany pocet znaku ===
    // Navratova hodnota:
    // TRUE  - zadano cele cislo
    // FALSE - neplatny vstup
    enum boolean {FALSE,TRUE};
    const int BUF_SIZE = 80;
    char vstup[BUF_SIZE],smeti[BUF_SIZE];
    fgets(vstup,sizeof(vstup),stdin);
    if(sscanf(vstup,"%i%[^\n]",cislo,smeti) != 1)
        return(FALSE); // Input error
    return(TRUE);
}// nextInt1() END


