/*
 * File:   C06d.c    25.08.2009 (rev: 06.09.2009)
 * Author: j.zdenek
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

// Pole - Eratosthenovo sito - tabulka prvocisel

// Function prototypes
void eratosthenovoSito (int mnozina[], int max);
void vypisPrvocisel(int mnozina[], int max);
int nextInt(int *cislo);

int main(int argc, char** argv) {
    #define MAX_LIMIT_PRO_HLEDANI_PRVOCISLA 100
    int max;
    int mnozina[MAX_LIMIT_PRO_HLEDANI_PRVOCISLA];
    printf(" === C06d.c ===\n\n");
    printf(" Eratosthenovo sito pro hledani provocisel \n\n");
    printf(" Zadejte limit pro hledani prvocisel <2, %d> = ",
           MAX_LIMIT_PRO_HLEDANI_PRVOCISLA);
    if(!nextInt(&max) || max > MAX_LIMIT_PRO_HLEDANI_PRVOCISLA ||
        max < 2){
        printf("\n Chyba - nespravne zadani \n\n");
        return(EXIT_FAILURE);
    }
    eratosthenovoSito(mnozina,max);
    vypisPrvocisel(mnozina,max);
    return (EXIT_SUCCESS);
}// main() END


void eratosthenovoSito (int mnozina[], int max){
    const int TRUE = 1;
    const int FALSE = 0;
    int i, p=2, pmax;
    for(i=2; i<=max; i++){
        mnozina[i]= TRUE;
    }
    pmax = (int)sqrt(max);
    do{
        // Vypusteni vsech nasobku cisla p
        for(i=p+p; i <=max; i+=p){
            mnozina[i] = FALSE;
        }
        // Hledani nejblizsiho cisla k p
        do{
           p++;
        }while(!mnozina[p]);
    }while(p <= pmax);
}// eratosthenovoSito() END


void vypisPrvocisel(int mnozina[], int max){
    int i;
    printf("\n Nalezena prvocisla do %3d \n\n",max);
    for(i=2; i <= max; i++){
        if(mnozina[i]){
            printf(" %4d \n", i);
        }
    }
    printf("\n");
}// vypisPrvocisel() END


int nextInt(int *cislo){
    // Stav: odladeno
    // === Bezpecne pro libovolny zadany pocet znaku ===
    // Navratova hodnota:
    // TRUE  - zadano cele cislo
    // FALSE - neplatny vstup
    enum boolean {FALSE,TRUE};
    const int BUF_SIZE = 80;
    char vstup[BUF_SIZE],smeti[BUF_SIZE];
    fgets(vstup,sizeof(vstup),stdin);
    if(sscanf(vstup,"%i%[^\n]",cislo,smeti) != 1)
        return(FALSE); // Input error
    return(TRUE);
}// nextInt() END

