/*
 * File:   C09b.c    27.08.2009 (rev: 05.09.2009)
 * Author: j.zdenek
 *
 */

#include <stdio.h>
#include <stdlib.h>

// Struktura, typedef, ukazatel - Kvadraticka rovnice 1
// Navratova hodnota = ukazatel na strukturu

typedef struct{
    double re1;
    double im1;
    double re2;
    double im2;
}Tcomplex;

// Function prototypes
Tcomplex* kvadratickaRovnice1(double a, double b, double c, int* chyba);
void vypisKorenuKvadratRovnice (char jmenoPromenne[], Tcomplex s);
void vypisKomplexCisla (double re, double im);
int nextDouble(double *cislo);


int main(int argc, char** argv) {
    Tcomplex s, *p;
    double a,b,c;
    int chybaVypoctu;
    printf(" === C09b.c ===\n\n");
    printf(" Kvadraticka rovnice 1 \n\n");
    printf(" Zadejte koeficienty a, b, c \n\n");
    if(!nextDouble(&a) || !nextDouble(&b) || !nextDouble(&c)){
        printf("\n Chyba - zadany udaj neni cislo\n\n");
        return(EXIT_FAILURE);
    }
    printf("\n");
    p = kvadratickaRovnice1(a,b,c,&chybaVypoctu);
    if(chybaVypoctu){
        printf(" Neplatne zadani (a=0) \n\n");
    }else{
        s = *p;
        vypisKorenuKvadratRovnice("Koren x",s);
    }
    return (EXIT_SUCCESS);
}// main() END

Tcomplex* kvadratickaRovnice1(double a, double b, double c, int* chyba){
    static Tcomplex koreny;
    // chyba = FALSE - vypocet platny
    // chyba = TRUE  - neplatny vstup
    const int TRUE = 1;
    const int FALSE = 0;
    double diskr = b * b - 4 * a*c;
    double odmocDiskr;
    *chyba = FALSE;
    if(a == 0)
        *chyba = TRUE;
    if (diskr >= 0) {
        odmocDiskr = sqrt(diskr);
        koreny.re1 = (-b + odmocDiskr) / (2 * a);
        koreny.im1 = 0;
        koreny.re2 = (-b - odmocDiskr) / (2 * a);
        koreny.im2 = 0;
    } else {
        odmocDiskr = sqrt(-diskr);
        koreny.re1 = -b / (2 * a);
        koreny.im1 = odmocDiskr / (2 * a);
        koreny.re2 = koreny.re1;
        koreny.im2 = -odmocDiskr / (2 * a);
    }
    return(&koreny);
}// kvadratickaRovnice1() END

void vypisKorenuKvadratRovnice (char jmenoPromenne[], Tcomplex s){
    printf(" %s1 = ",jmenoPromenne);
    vypisKomplexCisla(s.re1,s.im1);
    printf("\n\n");
    printf(" %s2 = ",jmenoPromenne);
    vypisKomplexCisla(s.re2,s.im2);
    printf("\n\n");
}// vypisKorenuRovniceCisla() END

void vypisKomplexCisla (double re, double im){
    if(im >= 0){
        printf("%.2f + j%.2f",re,im);
    }else{
        printf("%.2f - j%.2f",re,-im);
    }
}// vypisKomplexCisla() END

int nextDouble(double *cislo){
    // Stav: odladeno
    // === Bezpecne pro libovolny zadany pocet znaku ===
    // Navratova hodnota:
    // TRUE  - zadano realne cislo
    // FALSE - neplatny vstup
    enum boolean {FALSE,TRUE};
    const int BUF_SIZE = 80;
    char vstup[BUF_SIZE],smeti[BUF_SIZE];
    fgets(vstup,sizeof(vstup),stdin);
    if(sscanf(vstup,"%lf%[^\n]",cislo,smeti) != 1)
        return(FALSE); // Input error
    return(TRUE);
}// nextDouble() END

