/*
 * File:   C11a.h   12.09.2009
 * Author: j.zdenek
 *
 */

// Projekt z vice modulu (priklad C06l.c rozdeleny do 3 modulu
// a hlavickoveho souboru (header) *.h
//
// Pointers and arrays - dynamicka alokace pameti, malloc(), free()
// Otoc pole

#ifndef _C11A_H
#define	_C11A_H

// Constants
#define MAX_DELKA 20

// Function prototypes

// ========
// ctiPole2() dynamicky alokuje pole int p[] delky delka, ukazatel
// na alokovane pole vraci v p_pole. Maximalni delka alokovaneho pole
// je max_delka. Pokud pole nelze alokovat vraci p_pole==NULL.
// Do alokovaneho pole funkce nacte z klavesnice hodnoty vsech
// prvku (typu int)
// Vstup:   delka - pozadovana delka pole
//          max_delka - maximalni delka pole
// Vystup:  p_pole = ukazatel na alokovane pole
//          p_pole = NULL - pole nelze alokovat
// Navratova hodnota: zadna
void ctiPole2 (int **p_pole, int *delka, int max_delka);

// ========
// obratPole() - obrati poradi prvku v poli delky delka_pole.
// Vstup:   p - ukazatel na vstupni pole
//          delka_pole - delka vstupniho pole
// Vystup:  vstupni pole s obracenym poradi prvku
// Navratova hodnota: zadna
void obratPole (int p[], int delka_pole);

//========
// vypisPole() - vypise prvky pole p[] na obrazovku
// Vstup:   p - ukazatel na vstupni pole
//          delka_pole - delka vstupniho pole
// Vystup:  zadny
// Navratova hodnota: zadna
void vypisPole (int p[], int delka_pole);

// ========
// vratPole1() - dealokuje (vrati na "heap") pole alokovane
// funkci ctiPole2() a nastavi ukazatel *p_pole na NULL
// Vstup:   p_pole - ukazatel na alokovane pole
// Vystup:  p_pole = NULL
// Navratova hodnota: zadna
void vratPole1(int **p_pole);

//=========
// nextInt() - precte z klavesnice jedno cislo typu int do promenne *cislo,
// Promenna cislo musi by volana odkazem, aby nactena hodnota byla
// dostupna i mimo funkci nextInt(). Funkce nextInt() kontroluje zda
// bylo z klavesnice skutecne zadane cele cislo.
// Vstup:   cislo - promenna pro nasteni hodnoty z klavesnice
// Vystup:  cislo - hodnota nactena z klavesnice
// Navratova hodnota:
//          TRUE - cislo nacteno
//          FALSE - chyba, zadany udaj nebylo cele cislo
int nextInt(int *cislo);

#endif	/* _C11A_H */

